function linkify(inputText) {
    var replacedText, replacePattern1, replacePattern2, replacePattern3;
    replacePattern1 = /(https?:\/\/[^\s]+)/g;
    replacedText = inputText.replace(replacePattern1, '<a onclick="window.open(\'$1\', \'_system\');">$1</a>');
    replacePattern2 = /(^|[^\/])(www\.[\S]+(\b|$))/gim;
    replacedText = replacedText.replace(replacePattern2, '$1<a onclick="window.open(\'http://$2\', \'_system\');">$2</a>');
    return replacedText;
}

function textarearesize(pal) {
    console.log(pal);
    $('.chat[data-id="' + pal + '"] .chat-window').height(294 - $('.chat[data-id="' + pal + '"] textarea').height());
    $('.chat[data-id="' + pal + '"] .chatinputs .btn').height($('.chat[data-id="' + pal + '"] textarea').height());
}
function getMin(arr, prop) {
    var max;
    for (var i = 0; i < arr.length; i++) {
        if (!max || parseInt(arr[i][prop], 10) < parseInt(max[prop], 10))
            max = arr[i];
    }
    return max[prop];
}
var userid = [];
var username = [];
var roomid = [];
var original = document.title;
var timeout;
var drawns;
var openid = 0;
var keepactive = 0;
var answercall = 0;
var messageheight = 28;
var spamtimer;
var spamcount = 0;
var unreadcount = 0;
var unreadroom = [];
localStorage.bigroom = 0;
if (localStorage.chattabs == undefined)
    localStorage.chattabs = '[]';
if (localStorage.minitabs == undefined)
    localStorage.minitabs = '[]';
function mediabtn() {
    $('.chat[data-id="0"] .picupload').popover('hide');
    $('.chat[data-id="0"] .drawbtn').popover('hide');
    $('.chat[data-id="0"] .audbtn').popover('hide');
}
function picbtn() {
    $('.chat[data-id="0"] .medias').popover('hide');
    $('.chat[data-id="0"] .picupload').popover('show');
}
function drawbtn() {
    $('.chat[data-id="0"] .medias').popover('hide');
    $('.chat[data-id="0"] .drawbtn').popover('show');
}
function audbtn() {
    $('.chat[data-id="0"] .medias').popover('hide');
    $('.chat[data-id="0"] .audbtn').popover('show');
}
(function () {
    window.flashTitle = function (newMsg, howManyTimes) {
        function step() {
            document.title = document.title == original ? newMsg : original;
            if (--howManyTimes > 0 && activewin == 0) {
                timeout = setTimeout(step, 1000);
            }
        }
        howManyTimes = parseInt(howManyTimes, 10);
        if (isNaN(howManyTimes)) {
            howManyTimes = 5;
        }
        cancelFlashTitle(timeout);
        step();
    };
    window.cancelFlashTitle = function () {
        clearTimeout(timeout);
        document.title = original;
    };
}());
$(function () {
    $('#login').submit(function (event) {
        var $form = $(this), user = $form.find('input[name="username"]').val(), pass = $form.find('input[name="password"]').val();
        emaili = $form.find('input[name="email"]').val();
        if ($('#create').prop('checked') && emaili == '') {
            $('#error').html('<div class="alert alert-danger alert-dismissible" role="alert"><button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>Uutta tili\xe4 luodessa s\xe4hk\xf6posti ei saa olla tyhj\xe4!</div>');
        } else {
            if (user != '' && pass != '') {
                $.post(httptype + '://randomi.fi/inc/login.php', {
                    username: user,
                    password: pass,
                    email: emaili,
                    login: true
                }, function (data) {
                    if (data != 'false' && data != '') {
                        location.reload();
                    } else {
                        if (!$('#create').prop('checked') || emaili == '')
                            $('#error').html('<div class="alert alert-danger alert-dismissible" role="alert"><button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>Salasana tai k\xe4ytt\xe4j\xe4tunnus on v\xe4\xe4r\xe4!</div>');
                        else
                            $('#error').html('<div class="alert alert-danger alert-dismissible" role="alert"><button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>K\xe4ytt\xe4j\xe4tunnus on varattu</div>');
                    }
                });
            } else {
                $('#error').html('<div class="alert alert-danger alert-dismissible" role="alert"><button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>Salasana tai k\xe4ytt\xe4j\xe4tunnus on v\xe4\xe4r\xe4!</div>');
            }
        }
        event.preventDefault();
    });
});
$(document).keydown(function (e) {
    if (localStorage.shortcuts == 1) {
        switch (e.keyCode) {
        case 27:
            $('.disconnect').trigger('click');
            break;
        }
    }
});
function loadScript(url, callback) {
    var script = document.createElement('script');
    script.type = 'text/javascript';
    if (script.readyState) {
        script.onreadystatechange = function () {
            if (script.readyState == 'loaded' || script.readyState == 'complete') {
                script.onreadystatechange = null;
                callback();
            }
        };
    } else {
        script.onload = function () {
            callback();
        };
    }
    script.src = url;
    document.getElementsByTagName('head')[0].appendChild(script);
}
var users = [];
var userslist = "";
function friendmenu(update) {
	
	$('#chatmenu .friends ul').html(userslist);

	if(localStorage.cookie != "0" && localStorage.cookie != undefined) {
    if ($('#chatmenu .menubutton').hasClass('open') && update != 1) {
        $('#chatmenu .menubutton').removeClass('open');
        $('#chatmenu .friendlist').hide();
        $('#chatmenu .friendsearch').hide();
    } else {
        $.post(httptype + '://randomi.fi/handler.php', {
            friendlist: 'true',
            active: activewin,
            cook: localStorage.cookie
        }).done(function (data) {
            var ocount = 0;
			var friendcount = 0;
			unreadcount = 0
			
            if (data != '') {
			
				userslist = "";
				
                $.each($.parseJSON(data), function (k, v) {
                    users[v["uid"]] = [
                        v.askroom,
                        v.userid,
                        v.username,
                        v.status
                    ];
                    if (v.unread == 1) {
                        var newmsg = 'newmsg';
						$('.glyphicon-comment').addClass("newmsgs");
						unreadroom[v["askroom"]] = 1;
						unreadcount = unreadcount+1;
					} else
                        var newmsg = '';
						
                     userslist =  userslist + '<a><li class="user ' + v.status + ' ' + newmsg + '" data-id="' + v["uid"] + '"><img src="' + httptype + '://randomi.fi/src/minithumb/' + v.img + '" alt="" /><span class="username">' + v.username + '</span> <div class="status"></div><div class="bsets"></div></li></a>';
                    $('#minichats .chat' + v["uid"] + ' .minichatbtn').removeClass('online offline away').addClass(v.status);
                    if (roomid.indexOf(v.askroom) == -1)
                        socket.emit('join', {
                            room: v.askroom,
                            user: v.userid
                        }, function (err) {
                            if (err)
                                console.error(err);
                        });
                    roomid[v["uid"]] = v.askroom;
                    username[v["uid"]] = v.username;
                    userid[v["uid"]] = v.userid;
                    if (v.status != 'offline')
                        ocount = ocount + 1;
						friendcount = friendcount + 1;
                });
				
				$('#chatmenu .friends ul').html(userslist);
				
				if(unreadcount == 0)
					$('.glyphicon-comment').removeClass("newmsgs");
				
				var val = $('#chatmenu .friendsearch input').val();
				$('#chatmenu .friendlist li').each(function () {
					if ($(this).find('.username').html().toLowerCase().indexOf(val.toLowerCase()) == -1)
						$(this).hide();
					else
						$(this).show();
				});
            }
			if(friendcount == 0)
				$('#chatmenu .friends ul').append('<li class="user text-center" data-id=""><span class="username">'  + i18n.t("nofriends") + '</span></li>');
			
            $('.fonline').html('(' + ocount + ')');
            if (update != 1) {
                $('#chatmenu .menubutton').addClass('open');
                $('#chatmenu .friendlist').show();
                $('#chatmenu .friendsearch').show();
                $('#chatmenu .settings').hide();
                $('#chatmenu .settingsmenu').removeClass('open');
            }
			
			var longpress;
			var mousedowntime;
			var presstime;
			
			$(".friends li").on('mousedown touchstart' ,function() {
				var d = new Date();
				var that = $(this);
				mousedowntime = d.getTime();
				
				if($(this).find('.bsets').html() == "")
					$('.friends .bsets').html('');
				
				longpress=true;    
				var dataid = $(this).data("id");
				setTimeout(function() {    
					if(longpress && that.is(":hover")) {
					 that.parent().find('.bsets').html('<a class="btn btn-danger" onclick="rmfriend(' + dataid + ');">'  + i18n.t("delete") + '</a><a class="btn btn-warning" onclick="$(this).parent().html(\'\');">'  + i18n.t("cancel") + '</a>');      
								}  }, 1000);
			});
			$(".friends li").on('mouseup touchend' ,function() {
				longpress=false;
				var bsets = $(this).find('.bsets').html();
				var that = $(this);
				var d = new Date();
				presstime = d.getTime() - mousedowntime;
				var dataid = $(this).data("id");
				
				if(bsets == "") {
					$('.friends .bsets').html('');
					
					if (presstime > 999 && that.is(":hover")) {
						console.log("long");
						
						$(this).parent().find('.bsets').html('<a class="btn btn-danger" onclick="rmfriend(' + dataid + ');">'  + i18n.t("delete") + '</a><a class="btn btn-warning" onclick="$(this).parent().html(\'\');">'  + i18n.t("cancel") + '</a>');
					}
					else if(that.is(":hover")) {

						if(dataid != undefined)
							window.location.href = 'chat.html#' + dataid;
					}
				}
					
				
				
			});

			
        });
    }
	}
}
function friendsearch() {
    var val = $('#chatmenu .friendsearch input').val();
    if (val != '') {
		$.post(httptype + '://randomi.fi/handler.php', {
            searchfriend: val,
            cook: localStorage.cookie
        }).done(function (data) {
			 if (data != '' && data != "[]") {
				 $.each($.parseJSON(data), function (k, v) {
					if(v.isfriend != 2) {
						if(v.isfriend == 1) {
							var friendbtn = '<a class="btn btn-warning right">'  + i18n.t("asked") + '</a>';
						} else {
							var friendbtn = '<a class="btn btn-success right" onclick="addtofriend(' + v["id"] + ');">'  + i18n.t("add") + '</a>';
						}
						$('#chatmenu .addfriends ul').append('<a href="chat.html#' + v["id"] + '""><li class="user" data-id="' + v["id"] + '"><img src="' + httptype + '://randomi.fi/src/minithumb/' + v.img + '" alt="" /><span class="username">' + v.username + '</span> ' + friendbtn + '</li></a>');
					}
				 });
			 } else {
				$('#chatmenu .addfriends ul').html('');
			 }
		});
	
	
        $('#chatmenu .friendlist li').each(function () {
            if ($(this).find('.username').html().toLowerCase().indexOf(val.toLowerCase()) == -1)
                $(this).hide();
            else
                $(this).show();
        });
    } else {
        $('#chatmenu .friendlist li').show();
		$('#chatmenu .addfriends ul').html('');
    }
}
function closechat(pal) {
    $('.chat' + pal).remove();
    var idx2 = JSON.parse(localStorage.minitabs);
    idx2 = idx2.indexOf(pal);
    if (idx2 != -1) {
        var lol2 = JSON.parse(localStorage.minitabs);
        lol2.splice(idx2, 1);
        localStorage.minitabs = JSON.stringify(lol2);
    }
    var idx = JSON.parse(localStorage.chattabs);
    idx = idx.indexOf(pal);
    if (idx != -1) {
        var lol = JSON.parse(localStorage.chattabs);
        lol.splice(idx, 1);
        localStorage.chattabs = JSON.stringify(lol);
    }
}
function ignorechat(pal) {
    bootbox.confirm(i18n.t("sureignore"), function (result) {
        if (result == true) {
            $.post(httptype + '://randomi.fi/handler.php', {
                ignoreuser: pal,
                ignore: true
            }).done(function (data) {
                if (data == 'true') {
                    closechat(pal);
                    $('.user' + pal).hide();
                    friendmenu(1);
                    socket.emit('part', {
                        room: roomid[pal],
                        user: userid[pal]
                    });
                }
            });
        }
    });
    minimizechat(pal);
}
function minimizechat(pal, forced) {
    if ($('.chat[data-id="' + pal + '"]').length > 0) {
        if (forced == undefined)
            var forced = 0;
        if (($('.chat' + pal).hasClass('closed') || forced == 1) && forced != 2) {
            $('.chat' + pal).removeClass('closed');
            if (forced != 1) {
                $('.chat' + pal + ' .minichatbtn').addClass('btn-default').removeClass('btn-success');
                $('.chat' + pal + ' .chat-window').scrollTop($('.chat' + pal + ' .chat-window')[0].scrollHeight);
            }
            if (localStorage.minitabs != '')
                var idx = JSON.parse(localStorage.minitabs);
            else
                var idx = [];
            idx = idx.indexOf(pal);
            if (idx != -1) {
                var lol = JSON.parse(localStorage.minitabs);
                lol.splice(idx, 1);
                localStorage.minitabs = JSON.stringify(lol);
            }
        } else {
            $('.chat' + pal).addClass('closed');
            if (forced != 2)
                $('.chat' + pal + ' .minichatbtn').addClass('btn-default').removeClass('btn-success');
            var names = '';
            if (localStorage.minitabs != '')
                names = JSON.parse(localStorage.minitabs);
            if (names == '')
                names = [];
            if (names.indexOf(pal) == -1 && pal != -1)
                names.push(pal);
            localStorage.minitabs = JSON.stringify(names);
        }
    }
}
if (!Date.now) {
    Date.now = function () {
        return new Date().getTime();
    };
}
function openchat(pal, forced) {
    if (forced == undefined)
        var forced = 0;
    var names = '';
    if (localStorage.chattabs != '')
        names = JSON.parse(localStorage.chattabs);
    if (names == '')
        names = [];
    if (names.indexOf(pal) == -1 && pal != -1)
        names.push(pal);
    localStorage.chattabs = JSON.stringify(names);
    var names = '';
    if (localStorage.minitabs != '')
        names = JSON.parse(localStorage.minitabs);
    if (names == '')
        names = [];
    if (forced != 1 && names.indexOf(pal) != -1 && $('.chat[data-id="' + pal + '"]').length > 0) {
        minimizechat(pal, 2);
    } else if ($('.chat[data-id="' + pal + '"]').length > 0) {
        minimizechat(pal, 1);
    } else if (users[pal] != undefined) {
        
        
    }
}
function seemore(pal, timing) {
    $.post(httptype + '://randomi.fi/handler.php', {
        getmessages: 'true',
        limit: 20,
        from: timing - 1000,
        friend: pal,
        cook: localStorage.cookie
    }).done(function (data) {
        if (data != '') {
            var arr = JSON.parse(data);
            $('.chatdata .seemore').remove();
            if (arr.length > 0) {
                $.each(arr, function (idx, obj) {
                    if (obj.user == userid[pal])
                        who = 1;
                    else
                        who = 2;
                    if (obj.meta != undefined) {
                        if (obj.meta.type == 6 || obj.meta.type == 3 || obj.meta.type == 4 || obj.meta.type == 5)
                            obj.meta.type = 0;
                        if (obj.meta.time != undefined)
                            newmsg(obj.message, roomid[pal], who, obj.created, 0, obj.meta.type, 1, 1, 1);
                        else
                            newmsg(obj.message, roomid[pal], who, obj.created, 0, obj.meta.type, 1, 1, 1);
                    } else
                        newmsg(obj.message, roomid[pal], who, obj.created, 0, 0, 1, 1, 1);
                    $('.chat' + pal + ' .minichatbtn').addClass('btn-default').removeClass('btn-success');
                });
                $('.chatdata').prepend('<li onclick="seemore(' + pal + ',' + getMin(arr, 'created') + ')" class="seemore chat-line oldline">'  + i18n.t("seemore") + '</li>');
            }
        }
    });
}
function updatetabs() {
    if (localStorage.chattabs != '' && localStorage.chattabs != '[]') {
        var arr = JSON.parse(localStorage.chattabs);
        $.each(arr, function (idx, obj) {
            openchat(obj);
        });
    }
}
function settingsmenu() {
    $('#chatmenu .menubutton').removeClass('open');
    $('#chatmenu .friendlist').hide();
    $('#chatmenu .friendsearch').hide();
    if ($('#chatmenu .settingsmenu').hasClass('open')) {
        $('#chatmenu .settingsmenu').removeClass('open');
        $('#chatmenu .settings').hide();
    } else {
        $('#chatmenu .settingsmenu').addClass('open');
        $('#chatmenu .settings').show();
    }
}
function enablechat() {
    $.post(httptype + '://randomi.fi/handler.php', { enablechat: $('.ena input:checked').length, cook: localStorage.cookie });
    if ($('.ena input:checked').length == 0) {
        $('.menubutton, #minichats').hide();
        $('.menubutton').addClass('chatdisabled');
        var i;
        var that = this;
        for (i = 0; i < roomid.length; ++i) {
            if (i != 0 && roomid[i] != undefined) {
                that.socket.emit('part', {
                    room: roomid[i],
                    user: userid[i]
                }, function (err) {
                    if (err)
                        console.error(err);
                });
                that.roomid.splice(i, 1);
                that.userid.splice(i, 1);
            }
        }
    } else {
        $('.menubutton, #minichats').show();
        $('.menubutton').removeClass('chatdisabled');
        /*setInterval(function () {
            updatetabs();
        }, 2000); */
        updatetabs();
        setInterval(function () {
            friendmenu(1);
        }, 60000);
        friendmenu(1);
    }
}
function frequests() {
    if ($('.frequests').hasClass('open')) {
        $('.frequests').hide().removeClass('open').html('');
    } else {
        $.post(httptype + '://randomi.fi/handler.php', { getfrequests: true, cook: localStorage.cookie }).done(function (data) {
            if (data != '') {
                var arr = JSON.parse(data);
                $.each(arr, function (idx, obj) {
                    $('.frequests').append('<li class="fre' + obj.id + '" style="margin-bottom: 5px;"><a href="' + httptype + '://randomi.fi/profile/' + obj.username + '"><img src="' + httptype + '://randomi.fi/src/minithumb/' + obj.img + '"> ' + obj.username + '</a> <div class="btn-group right" role="group"><a onclick="rmfriend(' + obj.id + ')" class="btn btn-danger">'  + i18n.t("reject") + '</a><a onclick="allowfriend(' + obj.id + ')" class="btn btn-success">'  + i18n.t("accept") + '</a></div></li>');
                });
            }
        });
        $('.frequests').show().addClass('open');
    }
}

