var manual_or_random = "manual"
var randomsetting = "3 days"

function getCookie(Name) {
    if (localStorage.dark != undefined) return localStorage.dark;
    return null
}

function setCookie3(name, value, days) {
    localStorage.dark = value;
}

function deleteCookie(name) {
    localStorage.dark = "";
}

function setStylesheet(title, randomize) {
    var i, cacheobj, altsheets = [""]
    for (i = 0;
        (cacheobj = document.getElementsByTagName("link")[i]); i++) {
        if (cacheobj.getAttribute("rel").toLowerCase() == "alternate stylesheet" && cacheobj.getAttribute("title")) {
            cacheobj.disabled = true
            altsheets.push(cacheobj)
            if (cacheobj.getAttribute("title") == title) cacheobj.disabled = false
        }
    }
    if (typeof randomize != "undefined") {
        var randomnumber = Math.floor(Math.random() * altsheets.length)
        altsheets[randomnumber].disabled = false
    }
    return (typeof randomize != "undefined" && altsheets[randomnumber] != "") ? altsheets[randomnumber].getAttribute("title") : ""
}

function chooseStyle(styletitle, days) {
    if (document.getElementById) {
        setStylesheet(styletitle)
        setCookie3("mysheet", styletitle, days)
    }
}

function indicateSelected(element) {
    if (selectedtitle != null && (element.type == undefined || element.type == "select-one")) {
        var element = (element.type == "select-one") ? element.options : element
        for (var i = 0; i < element.length; i++) {
            if (element[i].value == selectedtitle) {
                if (element[i].tagName == "OPTION") element[i].selected = true
                else
                    element[i].checked = true
                break
            }
        }
    }
}


var selectedtitle = getCookie("mysheet")
if (document.getElementById && selectedtitle != null) setStylesheet(selectedtitle)
